#include <cassert>
#include <cstdio>
#include <cstring>
#include <vector>
using namespace std;

const int N = 100000;

int n, parent[N];

int find(int i) {
    return parent[i] == -1 ? i : (parent[i] = find(parent[i]));
}

vector <int> adjacent[N];
int size[N];

#define foreach(i, v) for(__typeof((v).begin()) i = (v).begin(); i != (v).end(); ++ i)

void dfs(int p, int u) {
    size[u] = 1;
    foreach (iter, adjacent[u]) {
        int v = *iter;
        if (v != p) {
            dfs(u, v);
            size[u] += size[v];
        }
    }
}

int main() {
    assert(scanf("%d", &n) == 1);
    assert(1 <= n && n <= N && n % 2 == 0);
    memset(parent, -1, sizeof(parent));
    for (int i = 0; i < n - 1; ++ i) {
        int a, b;
        assert(scanf("%d%d", &a, &b) == 2);
        assert(1 <= a && a <= n);
        assert(1 <= b && b <= n);
        a --;
        b --;
        assert(find(a) != find(b));
        parent[find(a)] = find(b);
        adjacent[a].push_back(b);
        adjacent[b].push_back(a);
    }
    dfs(-1, 0);
    int answer = -1;
    for (int i = 0; i < n; ++ i) {
        answer += !(size[i] & 1);
    }
    printf("%d\n", answer);
    return 0;
}
