#!/usr/bin/env ruby
require "timeout"

$problem = "matching"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
5.times { args << 10 }
5.times { args << 100 }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n|
    n = 1 + rand(max_n >> 1) + (max_n >> 1)
    input = [n]
    a = []
    n.times { a << [0] * n } 
    (1 + rand(n * (n - 1) / 2)).times do
        i, j = rand(n), rand(n) until i != j
        a[i][j] = a[j][i] = 1
    end
    n.times { |i| input << a[i].join(" ") }
    input
end
