#!/usr/bin/env ruby
require "timeout"

$problem = "product"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
8.times { args << 10 ** 3 }
2.times { args << 10 ** 5 }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |max_n|
    q = 1 + rand(max_n >> 1) + (max_n >> 1)
    input = [q]
    a = []
    q.times do 
        if a.empty? or rand(3) < 2 
            x = 2 + rand(10 ** 9 - 1)
            input << "insert #{x}"
            a << x
        else
            i = rand(a.size)
            input << "delete #{a[i]}"
            a.delete_at(i)
        end
    end
    input
end
