#include <cassert>
#include <cstdio>
#include <cstring>
using namespace std;

const int MOD = 1000000000 + 7;

int inverse(int a) {
    return a == 1 ? 1 : (long long)(MOD - MOD / a) * inverse(MOD % a) % MOD;
}

int main() {
    int q;
    assert(scanf("%d", &q) == 1);
    long long all_sum = 1;
    long long alt_sum = 1;
    while (q --) {
        char buffer[7];
        assert(scanf("%s", buffer) == 1);
        assert(strcmp(buffer, "insert") == 0 || strcmp(buffer, "delete") == 0);
        int x;
        assert(scanf("%d", &x) == 1);
        assert(2 <= x && x <= 1000000000);
        if (*buffer == 'i') {
            (all_sum *= (1 + x)) %= MOD;
            (alt_sum *= (1 + MOD - x)) %= MOD;
        } else {
            (all_sum *= inverse(1 + x)) %= MOD;
            (alt_sum *= inverse(1 + MOD - x)) %= MOD;
        }
        printf("%d\n", (int)((all_sum + MOD - alt_sum) * inverse(2) % MOD));
    }
    return 0;
}
