#!/usr/bin/env ruby
require "timeout"

$problem = "transform"

def generate(args)
    args.each_with_index do |arg, id|
        name = "%02d" %(id + 1)
        puts "#{$problem} \##{name}"
        File.open "#{name}.in", "w" do |f| 
            f.puts yield *arg
        end
        timeout(1) { `./#{$problem} < #{name}.in > #{name}.out` }
    end
end

args = []
20.times { args << 10 ** 5 }

`g++ #{$problem}.cpp -o #{$problem} -O2`
generate(args) do |n|
    a, b = 1 + rand(n), 1 + rand(n)
    a, b = b, a if a > b
    ["#{a} #{b}"]
end
