#include <cassert>
#include <cstdio>
#include <cstring>
using namespace std;

const int MOD = 1000000000 + 7;

int count[2][2], answer, x[3], y[3];

void dfs(int depth, int ways) {
    if (depth < 3) {
        for (int i = 0; i < 2; ++ i) {
            for (int j = 0; j < 2; ++ j) {
                x[depth] = i, y[depth] = j;
                dfs(depth + 1, (long long)ways * (count[i][j] --) % MOD);
                count[i][j] ++;
            }
        }
    } else if (((x[1] - x[0]) * (y[2] - y[0]) - (x[2] - x[0]) * (y[1] - y[0])) != 0) {
        (answer += ways) %= MOD;
    }
}

int main() {
    int n, m;
    assert(scanf("%d%d", &n, &m) == 2);
    assert(1 <= n && n <= 1000000000);
    assert(1 <= m && m <= 1000000000);
    memset(count, 0, sizeof(count));
    for (int x = 0; x < 2; ++ x) {
        for (int y = 0; y < 2; ++ y) {
            if (x < n && y < m) {
                count[x][y] = (long long)(n - x + 1 >> 1) * (m - y + 1 >> 1) % MOD;
            }
        }
    }
    answer = 0;
    dfs(0, 1);
    printf("%d\n", answer);
    return 0;
}
